/*
Executing gendsp code is not that easy in the context of the gen~ object in Max,
as copy/paste seems to be the only approach to getting code into a codebox object.
This script is used in the context of a helper tool, that waits for a textfile containing
genexpr code being updated, and executes the pasting of the code in a gendsp file automatically

The function readgdsp() imports the content of a .gendsp and stores it as an object. It is then
searched for a codebox object. A bang, because of saving the genexpr file, imports this file
and parses that in the gendsp patch, which is then saved to file

Finally, reloading the parent patch is required (a reload message does not suffice)
*/


var proj = {
	genPatcher : {},
	codeboxIndex : 0,
	gxprFilePath : '',
	gdspFilePath : ''
}

function bang() {
	// read .genexpr file, updated codebox and write .gendsp file
	var gxprFile = new File(proj.gxprFilePath)
	var codeString = ''
	var i=0, endFlag, oneChar

	if (gxprFile.isopen) {
		endFlag = gxprFile.eof
		for ( ; i<endFlag; i+=1) {
			oneChar = gxprFile.readchars(1)
			codeString += oneChar
		}
		gxprFile.close()
		proj.genPatcher.patcher.boxes[proj.codeboxIndex].box.code = codeString // update codebox content
		write(proj.gdspFilePath)
	} else {
		post('error+\n')
	}
}

function write(fpath) {
	// write .gendsp file
	var objAsString = JSON.stringify(proj.genPatcher)
	var destFile = new File(fpath, 'write', 'TEXT')
	var i=0, onechar
	if (destFile.isopen) {
		for ( ; i<objAsString.length; i+=1) {
			onechar = objAsString.charCodeAt(i)
			destFile.writebytes(onechar)
		}
		destFile.eof = objAsString.length
		destFile.close()
	} else {
		post('error+\n')
	}
	outlet(0, 'write', 'done')
}

function readgdsp(fpath) {
	// read .gendsp file, store as object and locate codebox
	var fileAsString = ''
	var gdspFile = new File(fpath, 'read')
	var i=0, endFlag, oneChar, boxes

	proj.gdspFilePath = fpath
	if (gdspFile.isopen) {
		endFlag = gdspFile.eof
		for ( ; i<endFlag; i+=1) {
			oneChar = gdspFile.readchars(1)
			fileAsString += oneChar
		}
		gdspFile.close()
	} else {
		post('error+\n')
	}
	// store as object
	proj.genPatcher = JSON.parse(fileAsString)
	// locate codebox
	boxes = proj.genPatcher.patcher.boxes // array with all boxes of which one is a codebox object
	for (i=0; i<boxes.length; i+=1) {
		if (boxes[i].box.maxclass === 'codebox') {
			proj.codeboxIndex = i
			break
		}
	}
}

function refergxpr(fpath) {
	proj.gxprFilePath = fpath
}




// 2 // 0 // 2 // 4 // © // j // v // k // r //